use std::error::Error;

use objects::YoutubeChannel;

mod objects;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    println!("Hello, world!!");
    let rid = get_channel("UCpDEe6JKiI5o8luXpk6UuiA".to_string()).await.unwrap();
    get_playlists("UCpDEe6JKiI5o8luXpk6UuiA".to_string(), rid).await;
    Ok(())
}

pub async fn get_playlists(channel_id: String, request_id: String) -> Result<(), Box<dyn Error>> {
    let client = reqwest::Client::new();

    let d= serde_json::json!({
         "context": {
           "client": {
             "clientName": "WEB",
             "clientVersion": "2.20201210.01.00",
             "originalUrl": "https://www.youtube.com/",
             "platform": "DESKTOP",
             "clientFormFactor": "UNKNOWN_FORM_FACTOR",
             "newVisitorCookie": true
           }
         },
         "browseId": channel_id,
         "params": request_id
        });

    let resp = client.post("https://www.youtube.com/youtubei/v1/browse?prettyPrint=false")
        .body(d.to_string())
        .send()
        .await?
        .text()
        .await?;

    println!("{}", resp);

    let resp: YoutubeChannel = serde_json::from_str(&resp).unwrap();

    println!("{:?}", resp.get_playlists());
    Ok(())
}

pub async fn get_channel(channel_id: String) -> Result<String, Box<dyn Error>>{
    let client = reqwest::Client::new();

    let resp = client.post("https://www.youtube.com/youtubei/v1/browse?prettyPrint=false")
        .body(r#"{
         "context": {
           "client": {
             "clientName": "WEB",
             "clientVersion": "2.20201210.01.00",
             "originalUrl": "https://www.youtube.com/",
             "platform": "DESKTOP",
             "clientFormFactor": "UNKNOWN_FORM_FACTOR",
             "newVisitorCookie": true
           }
         },
         "browseId": "UCpDEe6JKiI5o8luXpk6UuiA",
         "params": "EgZ2aWRlb3M%3D"
        }"#)
        .send()
        .await?
        .text()
        .await?;

    let resp: YoutubeChannel = serde_json::from_str(&resp).unwrap();

    Ok(resp.get_playlists_request_str().unwrap())
}